
#include <ggi/ggi.h>
#include <ggi/gwt.h>
#include <stdio.h>

ggi_pixel white, black, red, green, blue;

// Visible or Invalid ...
#define DRAW_REG(x) gwtDrawVisibleRegion(x)

void ClearWindow(gwt_window_t win)
{
  ggi_pixel fg, bg;
  gwtGetGCForeground(win, &fg);
  gwtGetGCBackground(win, &bg);
  gwtSetGCForeground(win, bg);
  gwtFillscreen(win);
  gwtSetGCForeground(win, fg);
  return;
}

#define REDRAW \
	ClearWindow(rootwin); \
	ClearWindow(subwin); \
	ClearWindow(subsubwin); \
	ClearWindow(subsubwin2); \
	DRAW_REG(rootwin); \
	DRAW_REG(subwin); \
	DRAW_REG(subsubwin); \
	DRAW_REG(subsubwin2); \
        gwtDrawBox(subwin, 10, 20, 25, 35); \
        gwtDrawBox(subwin, 155, 150, 35, 20); \
        gwtDrawBox(subsubwin, 10, 10, 15, 20); \
        gwtDrawBox(subsubwin2, 10, 10, 5, 10); \
        gwtDrawLine(subsubwin, 30, 15, 110, 90); \
	gwtmiFillPolygon(subsubwin, paintedSet, pGC, MI_SHAPE_GENERAL, MI_COORD_MODE_ORIGIN, 4, points); \
        gwtmiFillRectangles(subsubwin, paintedSet, pGC, 1, &rect); \
	gwtmiCopyPaintedSetToVisual(subsubwin, pGC, paintedSet, offset); \
	gwtmiClearPaintedSet(subsubwin, paintedSet); \
        gwtPuts(subwin, 25, 80, "GGI Covering"); \
        gwtPutc(subsubwin2, 25, 25, 'R'); \
        gwtPuts(rootwin, 20, 20, "Super-Rod, ... clipped!"); \
        gwtPuts(rootwin, 10, 360, "d)up c)down o)left p)right x)exit r)aise l)ower s)how h)ide i)print"); \
	ggiFlush(vis)


int main(int argc, char ** argv)
{
  ggi_event event;
  int x,y,h,w;
  int wx=2, wy=2;
  int ww=160, wh=120;
  int finished=0;

  ggi_visual_t vis;
  ggi_mode tm;
  gwt_window_t rootwin, subwin, subsubwin;
  gwt_window_t subsubwin2;
  ggi_color col;
  gwt_region_t reg;

  miGC *pGC;                /* graphics context */
  miPaintedSet *paintedSet; /* opaque object to be painted */
  //  miCanvas *canvas;         /* drawing canvas (including pixmap) */
  miPixel pixels[4];        /* pixel values for drawing and dashing */
  ggi_color colors[4];
  miPoint points[4];        /* 3 line segments in the polyline */
  unsigned int dashes[2];   /* length of `on' and `off' dashes */
  miPoint offset;           /* for miPaintedSet -> miCanvas transfer */
  miRectangle rect;                /* 1 arc to be drawn */
  miArc arc;

  ggiInit();
  gwtInit();
  vis=ggiOpen(NULL);
  gwtAttach(vis);
	
  ggiCheckGraphMode(vis, GT_AUTO, GT_AUTO, GT_AUTO, GT_AUTO, GT_AUTO, &tm);
  ggiSetMode(vis, &tm);

  col.r=col.g=col.b=0x0000;
  black=ggiMapColor(vis, &col);
  col.r=col.g=col.b=0xffff;
  white=ggiMapColor(vis, &col);
  col.g=col.b=0x0000;
  red=ggiMapColor(vis, &col);
  col.r=0x0000;
  col.g=0xffff;
  green=ggiMapColor(vis, &col);
  col.g=0x0000;
  col.b=0xffff;
  blue=ggiMapColor(vis, &col);

  gwtCreateRootWindow(NULL, vis, &rootwin);
  gwtCreateWindow(rootwin, &subwin);
  gwtCreateWindow(subwin, &subsubwin);
  gwtCreateWindow(subwin, &subsubwin2);

  /* Create empty painted set */
  paintedSet = gwtmiNewPaintedSet(subsubwin);
  /* Create new canvas (initPixel=0) */
  //  canvas = gwtmiNewCanvas(subsubwin, ww, wh, 0);
  /* Create new graphics context */
  pGC = gwtmiNewGC(subsubwin, 4, pixels, 0, NULL);
  offset.x = 0; offset.y = 0;

  gwtMove(subwin, wx, wy);
  gwtResize(subwin, 320, 240);
  gwtMove(subsubwin, wx, wy);
  gwtResize(subsubwin, ww, wh);

  gwtRegionCreate(&reg);
  gwtRegionSetRect(reg, wx+120, wy+160, 60, 60);
  gwtRegionAddRect(reg, wx+120, wy+160, 100, 20);
  gwtRegionAddRect(reg, wx+120+80, wy+160+30, 20, 20);
  gwtSetGeometry(subsubwin2, reg);
  gwtRegionDestroy(reg);

  gwtShow(subwin);
  gwtShow(subsubwin);
  /* Testing:
     gwtShow(subsubwin2);
  */
  gwtSetGCBackground(rootwin, white);
  gwtSetGCBackground(subwin, red);
  gwtSetGCBackground(subsubwin, green);
  gwtSetGCBackground(subsubwin2, blue);
  gwtSetGCForeground(rootwin, black);
  gwtSetGCForeground(subwin, black);
  gwtSetGCForeground(subsubwin, black);
  gwtSetGCForeground(subsubwin2, black);

  do {
    /* Define rectangle */
    rect.x = 10;
    rect.y = 15;   		/* upper left corner of bounding box */
    rect.width = 45;           /* x range of box: 20..50 */
    rect.height = 38;          /* y range of box: 15..31 */
    colors[0].r = random() % 0xffff; \
    colors[0].g = random() % 0xffff; \
    colors[0].b = random() % 0xffff; \
    colors[1].r = random() % 0xffff; \
    colors[1].g = random() % 0xffff; \
    colors[1].b = random() % 0xffff; \
    colors[2].r = random() % 0xffff; \
    colors[2].g = random() % 0xffff; \
    colors[2].b = random() % 0xffff; \
    colors[3].r = random() % 0xffff; \
    colors[3].g = random() % 0xffff; \
    colors[3].b = random() % 0xffff; \
    pGC->pixels[0] = ggiMapColor(vis, &colors[0]); \
    pGC->pixels[1] = ggiMapColor(vis, &colors[1]); \
    pGC->pixels[2] = ggiMapColor(vis, &colors[2]); \
    pGC->pixels[3] = ggiMapColor(vis, &colors[3]); \
    points[0].x = random() % ww; \
    points[0].y = random() % wh; \
    points[1].x = random() % ww; \
    points[1].y = random() % wh; \
    points[2].x = random() % ww; \
    points[2].y = random() % wh; \
    points[3].x = random() % ww; \
    points[3].y = random() % wh; \
    dashes[0] = random() % 20; \
    dashes[1] = random() % 20; \
    x = random() % ww; \
    y = random() % wh; \
    w = random() % (ww-x) + 1; \
    h = random() % (wh-y) + 1; \
    gwtmiSetGCAttrib(subsubwin, pGC, MI_GC_LINE_STYLE, MI_LINE_ON_OFF_DASH); \
    gwtmiSetGCDashes(subsubwin, pGC, 2, dashes, 0); \
    gwtmiSetGCAttrib(subsubwin, pGC, MI_GC_LINE_WIDTH, random() % 50);

    REDRAW;
					     
    gwtValidateAll(rootwin);
    gwtValidateAll(subwin);
    gwtValidateAll(subsubwin);
    gwtValidateAll(subsubwin2);

    gwtEventRead(rootwin,&event,emAll);
    gwtGetPointerLocation(rootwin,&x,&y);

    switch (event.any.type)
      {
      case evKeyPress:
      case evKeyRepeat:
	switch (event.key.sym)
	  {
	  case 'd':		/* up*/
	    wy-=16; wh+=6; break;
	  case 'c':		/* down */
	    wy+=16; wh-=6; break;
	  case 'o':		/* left */
	    wx-=16; ww+=6; break;
	  case 'p':		/* right */
	    wx+=16; ww-=6; break;
	  case 't':		/* right */
	    if (gwtIsHidden(subwin)) gwtShow(subwin); else gwtHide(subwin); break;
	  case 'x': case ' ': case GIIUC_Escape: /* finish */
	    finished=1; break;
	  case 'r':              /* raise */
	    gwtRaise(subsubwin, NULL); break;
	  case 'l':               /* lower */
	    gwtLower(subsubwin, NULL); break;
	  case 's':              /* show */
	    gwtShow(subsubwin); break;
	  case 'h':               /* hide */
	    gwtHide(subsubwin); break;
	  case 'i':               /* print windows on stderr */
	    gwtDebugPrintWindows(rootwin); break;
	  }
	break;
      case evPtrAbsolute:
      case evPtrRelative:
	break;
      case evExpose:
	break;
      }

    gwtShow(subsubwin2);
    gwtMove(subwin, wx, wy);

    gwtMove(subsubwin, wx, wy);
    gwtResize(subsubwin, ww, wh);

  } while (!finished);

  ggiFlush(vis);

  gwtDestroy(rootwin);	/* closes children first */
  gwtDetach(vis);
  ggiClose(vis);
  gwtExit();
  ggiExit();
  exit(0);
}

